/*Code By DRS : https://www.youtube.com/channel/UCl9vi6y04pBl-RajOrFJI8g*/
/*La communication full-duplex fonctionne correctement*/
/*Transmetteurmodelisé par la LED Rouge*/
#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
#define led 6
#define button 4
#define buzzer 5 
#define potar A0

typedef struct{
  boolean b1=0;
  boolean b2=0;
  int p1=0;
}data;
data payload;


RF24 radio(7, 8); // CE, CSN
const byte addresses[][6] = {"00001", "00002"};
int ack=0;

void setup() {
  pinMode(button, INPUT);
  pinMode(led, OUTPUT);
  pinMode(buzzer, OUTPUT);
  pinMode(potar, INPUT);
  radio.begin();
  radio.setChannel(125);
  radio.openWritingPipe(addresses[0]); // 00001
  radio.openReadingPipe(1, addresses[1]); // 00002
  radio.setPALevel(RF24_PA_MIN);
}
void loop() {
  delay(5);
  /**********[RECEPTION]***********************/
  radio.startListening();
  reception();
   /********************************************/
    delay(5);
   /****************[EMIT]**********************/
   radio.stopListening();
   emitting();
  /*************************************************/
}

void reception(){
  if(radio.available()){
    radio.read(&payload, sizeof(payload));
    
    if(ack==0){ /*Si la communication est établie alors la fonction startcom est lancé*/
      ack=100;
      startcom();
    }
    
    if (payload.b2 == HIGH) {
      digitalWrite(led, HIGH);
    }
    else {
      digitalWrite(led, LOW);
    }
  }
  else{
    if(ack>1){
      ack=0;
    }
  }
}

void emitting(){
    payload.b1 = digitalRead(button);
    payload.p1 = analogRead(potar);
    radio.write(&payload, sizeof(payload));
}

void startcom(){ /* est lancé si la communication est établie*/
  digitalWrite(buzzer, HIGH);
  delay(50);
  digitalWrite(buzzer, LOW);
  delay(50);
  digitalWrite(buzzer, HIGH);
  delay(50);
  digitalWrite(buzzer, LOW);
}
